unit Main ;

{ Jednotka hlavnho okna pro vzorov projekt (WB_D_API.DPR) zaloen na td
  TWBMainForm  }

interface
{ Do klausule uses pridany unity WinBase a WBParent}
uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls,WinBase,WBParent;

type
{Hlavni okno TMainForm MDI aplikace odvozeno z uzivatelskeho formulare
 TWBMainForm:}
  TMainForm = class(TWBMainForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    Edit1: TMenuItem;
    CutItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    SpeedPanel: TPanel;
    OpenBtn: TSpeedButton;
    SaveBtn: TSpeedButton;
    CutBtn: TSpeedButton;
    CopyBtn: TSpeedButton;
    PasteBtn: TSpeedButton;
    ExitBtn: TSpeedButton;
    StatusBar: TStatusBar;
    WinBase6021: TMenuItem;
    AplikacePRIKLADY: TMenuItem;
    AplikacePER_AGENDA: TMenuItem;
    ZavritVse: TMenuItem;
    AplikaceSERVIS: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FileNewItemClick(Sender: TObject);
    procedure WindowCascadeItemClick(Sender: TObject);
    procedure WindowTileItemClick(Sender: TObject);
    procedure WindowArrangeItemClick(Sender: TObject);
    procedure FileCloseItemClick(Sender: TObject);
    procedure FileOpenItemClick(Sender: TObject);
    procedure FileExitItemClick(Sender: TObject);
    procedure FileSaveItemClick(Sender: TObject);
    procedure FileSaveAsItemClick(Sender: TObject);
    procedure CutItemClick(Sender: TObject);
    procedure CopyItemClick(Sender: TObject);
    procedure PasteItemClick(Sender: TObject);
    procedure WindowMinimizeItemClick(Sender: TObject);
    procedure AplikacePER_AGENDAClick(Sender: TObject);
    procedure ZavritVseClick(Sender: TObject);
//    procedure AplikacePRIKLADYClick(Sender: TObject);
//    procedure AplikaceSERVISClick(Sender: TObject);
  private
    procedure CreateMDIChild(const Name: string);
    procedure ShowHint(Sender: TObject);
  public

  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses ChildWin, LogForm;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.OnHint := ShowHint;
end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  StatusBar.Panels[0].Text := Application.Hint;
  StatusBar.Panels[1].Text := ' ';
end;

procedure TMainForm.CreateMDIChild(const Name: string);
var
  Child: TMDIChild;
begin
  { create a new MDI child window }
  Child := TMDIChild.Create(Application);
  Child.Caption := Name;
end;

procedure TMainForm.FileNewItemClick(Sender: TObject);
begin
  CreateMDIChild('NONAME' + IntToStr(MDIChildCount + 1));
end;

procedure TMainForm.FileOpenItemClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    CreateMDIChild(OpenDialog.FileName);
end;

procedure TMainForm.FileCloseItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    ActiveMDIChild.Close;
 { CloseActiveMDIChild;}
end;

procedure TMainForm.ZavritVseClick(Sender: TObject);
{ Uzavre vsechna detska okna vytvorena v Delphi}
var I: Integer;
begin
  for I := 0 to MDIChildCount - 1 do
    MDIChildren[I].Close;
end;

procedure TMainForm.FileSaveItemClick(Sender: TObject);
begin
  { save current file (ActiveMDIChild points to the window) }
end;

procedure TMainForm.FileSaveAsItemClick(Sender: TObject);
begin
  { save current file under new name }
end;

procedure TMainForm.FileExitItemClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.CutItemClick(Sender: TObject);
begin
  {cut selection to clipboard}
end;

procedure TMainForm.CopyItemClick(Sender: TObject);
begin
  {copy selection to clipboard}
end;

procedure TMainForm.PasteItemClick(Sender: TObject);
begin
  {paste from clipboard}
end;

procedure TMainForm.WindowCascadeItemClick(Sender: TObject);
begin
  Cascade;
end;

procedure TMainForm.WindowTileItemClick(Sender: TObject);
begin
  Tile;
end;

procedure TMainForm.WindowArrangeItemClick(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TMainForm.WindowMinimizeItemClick(Sender: TObject);
var
  I: Integer;
begin
  { Must be done backwards through the MDIChildren array }
  for I := MDIChildCount - 1 downto 0 do
    MDIChildren[I].WindowState := wsMinimized;
end;

procedure list_server_names;
//Procedra napln FormLogin.ComboBox1 seznamem registrovanch server WinBase602
const key = 'SOFTWARE\Software602\WinBase602\Database';
var   server_name :array[0..126] of Char;
      polozka : Integer;
      h_Key: HKEY;
begin
 if RegOpenKeyEx(HKEY_LOCAL_MACHINE, key, 0, KEY_READ, h_Key) <> ERROR_SUCCESS
   then exit;
 polozka := 0;
 while TRUE do begin
  if RegEnumKey(h_Key, polozka, server_name, SizeOf(server_name)) <> ERROR_SUCCESS
    then System.break;
  FormLogin.ComboBox1.Items.Add(string(@server_name));
  inc(polozka);
 end;
  RegCloseKey(h_Key);
  FormLogin.ComboBox1.ItemIndex := 0;
end;

(***** Klient se napoji na WinBsi a spusti aplikaci PER_AGENDA ***************)
procedure TMainForm.AplikacePER_AGENDAClick(Sender: TObject);
const NameU = nil;
      Password = nil;
      Appl = 'PER_AGENDA';
var   Uspech: Boolean;
      Server: string;
begin
// Pkazov dek programu wb_d_api.exe me obsahovat jedin parametr - nzev
// serveru WinBase602
  if ParamStr(1) = '' then  begin
  // Jmno serveru nebylo zadno z pkazovho dku, pkazov dek neobsahuje
  // tedy dn parametry. V takovm ppad je zobrazen dialogov box pro vbr
  // serveru z mnoiny registrovanch server WinBase602.
    try
     FormLogin := TFormLogin.Create(self);
     list_server_names;// Naplnn ComboBoxu seznamem server WinBase602
     FormLogin.ShowModal;
     Server := FormLogin.ComboBox1.Text;
    finally
     FormLogin.Free;
    end;
  end else
  // Jmno serveru bylo zadno z pkazovho dku jako parametr
  // nap. wb_d_api.exe WB5, je-li jmno serveru WB5 :
    Server := ParamStr(1);

  if not WBInit(PChar(Server), NameU, Password, Appl) then  close;
  Uspech := Open_project('MIN_PLAT');
  if (Uspech = False) then Info_box('Chyba','Nelze otevrit projekt');
Main_menu('*AGENDA');
end;(************************** ****************** ****************************)

(***** Klient se napoji na WinBsi a spusti aplikaci PRIKLADY ******************
procedure TMainForm.AplikacePRIKLADYClick(Sender: TObject);
const Server = 'WB5';
      Name = nil;
      Password = nil;
      Appl = 'PKLADY';
var Uspech : Boolean;
begin
 if not WBInit(Server, Name, Password, Appl) then  close;
 Main_menu('*HLAVN');
end; ************************** ****************** ****************************)

(***** Klient se napoji na WinBsi a spusti aplikaci SERVIS **************
procedure TMainForm.AplikaceSERVISClick(Sender: TObject);
const Server = 'WB5';
      Name = nil;
      Password = nil;
      Appl = 'SERVIS';
var Uspech : Boolean;
begin
 if not WBInit(Server, Name, Password, Appl) then  close;
 Uspech := Open_project('SERVIS');
 if (Uspech = False) then Info_box('Chyba','Nelze otevrit projekt');
 Main_menu('*HLAVN');
end; ************************** ****************** ****************************)

end.
