//
// (C) Pavel Kubricht, Vit Boukal 1997
// Verze 1.0 z: unor, 1997
//

unit WBParent;

{ Unit WBParent implementuje predka TWBMainForm rmcovho okna (ktere zde
 nazyvame TMainForm - viz unit Main) pro vasi MDI aplikaci Delphi, ktery predevsim :
  1) zapouzduje funknost pro napojen k a odpojen od WinBase602
  2) zajituje predvn zprv mezi databzovm serverem WinBase602 a Delphi. }

interface
{ Do klausule uses pridana unita WinBase:}
uses SysUtils,Forms,Classes,Graphics,WinProcs,Messages,Controls,WinBase,Dialogs;

type
  { Druhy chyb, ktere mohou vzniknout v metode WBInit: }
  TIniErr = (WBINI_LINKERR,WBINI_INTERFERR,WBINI_LOGERR,WBINI_SETAPPLERR);

  { Predek TWBMainForm vaseho hlavniho okna MDI Delphi aplikace: }
  TWBMainForm = class(TForm)
  private
   { Indikuje pripojeni klienta na WinBasi: }
    Logged : boolean;
   { Promenna pro prubezne ulozeni informaci o kontextu komunikace : }
    cd : cd_t;
   { Vola se, kdyz nastane udalost onClose hlavniho okna MDI aplikace Delphi: }
    procedure OnCloseHandler(Sender: TObject; var Action : TCloseAction);
  protected
    hHlMenu, hWinMenu: HMENU;
   { Zobrazi okenka chybovych hlaseni pro chyby vznikle ve funkci WBInit: }
    procedure WBInitErr(ErrType : TIniErr; err : integer);virtual;
  public
{Flags - Urceni zda hlavni okno bude pouzivat ovladaci a stavovou listu
z WinBase602 ci z Delphi :}
    Flags: integer;
{Slouzi ke zpracovani zprav WM_COMMAND prijatych z WinBase602: }
    procedure WMCOMMAND(var Msg: TMessage); message WM_COMMAND;
{Slouzi k ovldn Delphovskeho statusbaru na zaklade winbasovske
 zpravy SZM_SETSTATUSTEXT: }
    procedure SZMSETSTATUSTEXT(var Message: TMessage); message SZM_SETSTATUSTEXT;
{Slouzi k nastaveni ci vyberu Delphovskeho toolbaru v zavislosti
na typu winbasovskeho okna urceneho winbasovskou zpravou SZM_SETTOOLBAR: }
    procedure SZMSETTOOLBAR (var Message: TMessage); message SZM_SETTOOLBAR;
{Slouzi k predavani zprav WinBasi :}
    procedure WndProc(var Msg: TMessage); override;
{Create pouzit pro akce inicializujici WinBasi : }
    constructor Create(AOwner : TComponent); override;
{ Provadi pripojeni klienta k WinBasi a nastavuje Logged: }
    function WBInit(Server, Name, Password, Appl : PCHar) : Boolean;
{ Provadi odpojeni klienta od WinBase: }
    procedure WBEnd;
{ Uzavira aktivni detske okno: }
    procedure CloseActiveMDIChild;
{Nastaveni viditelnosti list vytvorenych v Delphi :}
    procedure Listy(Visib: Boolean);
end;

implementation
uses Main; { Main je jmeno unity, ve ktere je implementovano hlavni okno vasi
            MDI Delphi aplikace - zde TMainForm }

procedure TWBMainForm.WBEnd;
(****** Metoda implementuje vlastn odpojen od WinBase ***********************)
begin
 if Logged then
   begin
{ Spolu s ukoncenim WinBase602 uzavreme vsechny jeji pohledy :}
    Close_all_views;
    Logout;
    interf_close;
   { unlink_kernel;}
    Logged := FALSE; {Nastaveno pro pripad, ze bychom znovu volali metodu WBEnd}
   end
end;

procedure TWBMainForm.OnCloseHandler(Sender: TObject; var Action : TCloseAction);
begin
  WBEnd;
end;

(************* Zavira aktivni detske okno vcetne aktivniho pohledu ***********)
procedure TWBMainForm.CloseActiveMDIChild;
var hwndChild : HWND;
begin
 hwndChild := LOWORD(SendMessage(ClientHandle, WM_MDIGETACTIVE, 0, 0));
 SendMessage(ClientHandle, WM_MDIDESTROY, hwndChild, 0);
end;

procedure TWBMainForm.Listy(Visib: Boolean);
{Nastaveni viditelnosti list vytvorenych v Delphi :}
begin
 MainForm.SpeedPanel.Visible := Visib;
 MainForm.StatusBar.Visible := Visib;
end;

constructor TWBMainForm.Create(AOwner : TComponent);
var WndMnuIndex: Integer;
begin
 inherited Create(AOwner);
   color := clGreen;
   {Inicializace promenne kontextu komunikace cd : }
   cdp_init(@cd);
   { Udlosti onClose je pridelena metoda OnCloseHandler :}
   OnClose := OnCloseHandler;

{Parametry hlavniho okna MDI aplikace, ktere musime predat WinBasi :}
{ 1) Nastaveni Flags:
Urceni zda hlavni okno bude pouzivat ovladaci a stavovou listu z WinBase602
ci z Delphi.
Omezeni:  Neni mozne kombinovat listy z WinBase a Delphi tj. pouzit toolbar
     z WinBase a stavovou listu z Delphi ci naopak.
}
Flags :={ 0;}  WBF_NO_TOOLBAR or WBF_NO_STATUSBAR; // Te pouvme lity z Delphi
{ 2)Nastaveni indexu submenu Window:}
 if (WindowMenu <> nil) then
   {Poradove cislo submenu Window v hlavnim menu :}
  WndMnuIndex := WindowMenu.MenuIndex
 else
   {Submenu Window neexistuje: }
  WndMnuIndex := -1;

Listy(False);
//WinBase zjisti,kdo je MDIFrame a MDIClient :
Init_window_env(WindowHandle, ClientHandle, WndMnuIndex, Flags);
if Flags <> 0 then Listy(True);
{Pokud se pri uzavreni nebo opusteni editoru ma vratit puvodni menu, musi byt
 predem registrovano procedurou Register_ext_menu:}

  hHlMenu := GetMenu(WindowHandle);
  if WindowMenu <> nil then
  begin
    hWinMenu := GetSubMenu(hHlMenu, WndMnuIndex);
    Register_ext_menu(WindowHandle, hHlMenu, hWinMenu);
  end;
end;

procedure TWBMainForm.WBInitErr(ErrType : TIniErr; err : integer);
begin
 case ErrType of
   WBINI_LINKERR,
   WBINI_INTERFERR:  Kernel_error_box(err);
   WBINI_LOGERR:     Info_box('Chyba','Chybn heslo');
   WBINI_SETAPPLERR: Info_box('Chyba','Zadan aplikace v databzi nen');
 end;
end;

function TWBMainForm.WBinit(Server, Name, Password, Appl : PCHar) : boolean;
(****** Metoda implementuje vlastn napojen na WinBasi ***********************)
var err : integer; { cislo chyby }
begin
 Logged := FALSE; { jeste nejsme prihlaseni}
 WBInit := TRUE; { bude-li nekde neuspech, nastavi se na FALSE }
 err := link_kernel(Server, SW_MINIMIZE); { volba nebo spusteni serveru }
 if err <> KSE_OK then
 begin {1}    { chyba v link_kernel }
   WBInitErr(WBINI_LINKERR, err);
   WBInit := FALSE;  { vystup z fce WBInit pri neuspechu}
 end  {1}
 else
 begin  {1}  { uspech v link_kernel }
   err := interf_init(@cd, 0); { pripojeni klienta na server }
   if err <> KSE_OK then
   begin {2}  { chyba v interf_init }
    { unlink_kernel();}
     WBInitErr(WBINI_INTERFERR, err);
     WBInit := FALSE; { vystup z fce WBInit pri neuspechu}
   end {2}
   else
   begin {2} { uspech v interf_init }
     if Name = nil then
       begin {3}
	 Logged := Alogin(WindowHandle); { Dotaz na Name a Password }
       end {3}
       else
       begin {3}
	 if Password = nil then
           Password := '';
	   Logged := not Login(Name, Password);
	   if (not Logged) then
	     WBInitErr(WBINI_LOGERR, 0);
       end; {3}
    	  if not Logged then
	    begin {4}  { Neuspesne prihlaseni klienta : Logged = FALSE; }
	      interf_close;
             { unlink_kernel;}
	      WBInit := FALSE; { vystup z fce WBInit pri neuspechu}
	    end {4}
            else { Uspesne prihlaseni klienta : Logged = TRUE; }
              if (Appl <> nil) and Set_application(Appl) then
	      begin {5} { pri uspechu vraci Set_application() FALSE }
	        WBInitErr(WBINI_SETAPPLERR, Sz_error);
                LogOut;
                Logged := false;
		interf_close();
               {unlink_kernel();}
		WBInit := false; { vystup z fce WBInit pri neuspechu }
	      end {5}
   end; {2}
 end; {1}
end; { Konec WBInit }

{********** Slouzi ke zpracovani zprav WM_COMMAND z WinBase602 : **************}
procedure TWBMainForm.WMCOMMAND(var Msg: TMessage);
const MSG_KONEC = 1001;
begin
 inherited;
 if Msg.wParam = MSG_KONEC then
{
Kliknuli jsme na polozku Konec ( ci Ukoncit apod.) v menu Winbase602.
Vzorove aplikace dodvan s WinBase602 pouzivane v tomto prikladu musite doplnit
tak, aby polozka winbasovskeho menu ukoncujici aplikaci vyslala pri sve aktivaci zpravu 1001.
}
     begin                 { a tim ukoncime aplikaci WinBase602 - }
     { Odpojime se od WinBase602: }
      WBEnd;
      if Flags <> 0 then Listy(True);
     { Nastavime puvodni menu vytvorene v Delphi: }
      SetMenu(WindowHandle,hHlMenu);
     end;
 if Msg.wParam = 91 then Tile;{Kliknuli jsme na polozku Mozaika menu Winbase602}

 if Msg.wParam = 92 then Cascade;{Kliknuli jsme na polozku Kaskda menu Winbase602}
end;(************************** ****************** ****************************)

(***************** Ovldn delphovskeho statusbaru ***************************)
procedure TWBMainForm.SZMSETSTATUSTEXT(var Message: TMessage);
begin
// Parametry winbasovske zpravy SZM_SETSTATUSTEXT :
// wParam = 0, jde-li o text
// wParam = 1, jde-li o cisla (nap. interni/externi cislo zaznamu)
// lParam = vlastni obsah urceny pro listu :text ci cisla
  if Flags <> 0 then {pouzivame-li stavovou listu Delph, pak ji nastavime: }
  begin
    if Message.wParam = 0 then {text do leveho panelu}
     MainForm.StatusBar.Panels[0].Text := PChar(Message.lParam)
    else {cisla zaznamu do praveho panelu}
     MainForm.StatusBar.Panels[1].Text := ' NUM  ' + string(PChar(Message.lParam));
  end;
end;(************************** ****************** ****************************)

(******** Nastaveni ci vyber delphovskeho toolbaru v zavislosti na typu *******
 ****** winbasovskeho okna urceneho winbasovskou zpravou SZM_SETTOOLBAR: ******)
procedure TWBMainForm.SZMSETTOOLBAR (var Message: TMessage);
begin
// Demonstrace nastavovani toolbaru :
// (uplny vycet konstant typu WB_TB_... najdete v jednotce WinBase.pas.
// Tyto konstanty odpovdaj jednotlivym typum winbasovskych oken.)

 case Message.WParam of
  WB_TB_UNKNOWN    : begin
              MainForm.SpeedPanel.Caption := 'toolbar pro WB_TB_UNKNOWN     ';
              MainForm.OpenBtn.Visible := False;
              MainForm.SaveBtn.Visible := False;
                     end;
  WB_TB_DEFAULT    : begin
              MainForm.SpeedPanel.Caption := 'toolbar pro WB_TB_DEFAULT     ';
              MainForm.OpenBtn.Visible := True;
              MainForm.SaveBtn.Visible := True;
                     end;
  WB_TB_VIEW       : begin
              MainForm.SpeedPanel.Caption := 'toolbar pro WB_TB_VIEW     ';
              MainForm.OpenBtn.Visible := False;
              MainForm.SaveBtn.Visible := False;
                     end;
  WB_TB_HIST       : begin
              MainForm.SpeedPanel.Caption := 'toolbar pro WB_TB_HIST     ';
              MainForm.OpenBtn.Visible := True;
              MainForm.SaveBtn.Visible := False;
                     end;
  WB_TB_EDITTEXT   : begin
              MainForm.SpeedPanel.Caption := 'toolbar pro WB_TB_EDITTEXT     ';
              MainForm.OpenBtn.Visible := False;
              MainForm.SaveBtn.Visible := True;
                     end;
 end;
end;(************************** ****************** ****************************)

procedure TWBMainForm.WndProc(var Msg: TMessage);
{Slouzi k predavani zprav (hlavniho okna MDI aplikace) WinBasi602, ktera provede
svou vlastni (nutnou) obsluhu nekterych zprav. Delphi predaji zpravy WinBasi
volanim funkce WinBaseFrameProc(Handle,Msg, WParam, LParam).
Tim, ze je fce WinBaseFrameProc(Handle,Msg, WParam, LParam) umistena do WndProc,
provede se nejdrive zpracovani zprav WinBasi a teprve pak zpracovani v Delphi
(v EventHandlerech ci MessageHandlerech atd.). Chcete-li toto poradi zmenit,
umistete vlastni zpracovani do TWBMainForm.WndProc pred volani fce
WinBaseFrameProc() ci do TMainForm.WndProc ( kde TMainForm je vase hlavni
MDI okno, ktere odvodite jako potomka tridy TWBMainForm ) pred volani
inherited WndProc(Msg).
}
var Ret : uns32;
begin
{WM_CREATE nepredame do WinBaseFrameProc(),nebot volame Init_window_env.
 WM_SIZE predame bud WinBasi nebo Delphi dle toho, ci listy pouzivame}
 if Msg.Msg <> WM_Close then
  if (Flags = 0) or (Flags= WBF_NO_TOOLBAR) or (Flags = WBF_NO_STATUSBAR) then
  {pouzivame aspon jednu listu z WinBase => Zpravu WM_SIZE bude dostavat WinBase}
  begin {2}
   if Msg.Msg <> WM_CREATE then begin {1}
    with Msg do Ret := WinBaseFrameProc(WindowHandle, Msg, WParam, LParam);
    if(Ret = 0) then { WinBase zpravu zpracovala : Ret = 0}
        Msg.Result := 0;
   end;{1}
    if Msg.Msg <> WM_SIZE then
     inherited WndProc(Msg);
  end {2}

  else {2}
  {pouzivame listy z Delphi => Zpravu WM_SIZE bude dostavat Delphi}
  begin {2}
  if (Msg.Msg <> WM_CREATE) and (Msg.Msg <> WM_SIZE) then begin {3}
    with Msg do Ret := WinBaseFrameProc(WindowHandle, Msg, WParam, LParam);
    if(Ret = 0) then { WinBase zpravu zpracovala : Ret = 0}
        Msg.Result := 0;
    end;{3}
    inherited WndProc(Msg);
  end {2}
 else Close;
end;

end.


